{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit ConTools;

interface

uses Dos,Crt,VdtDisp,Colors,VdtTools,Video60,XSer,InterCon,DirCon,
     Stringer,EmulM2,RamDisk2,ForSave,Error;

Var  GenVD     : VDispRec;
     VDInUse   : Boolean;

     BackRam   : PVDispRam;
     BackDRCS  : PVDispRamDRCS;

Procedure AfficheBack;
Procedure RAffPage;
Procedure CompoChg( nLn, Nb : Byte );
Procedure LnRAff( nLn : Byte );
Procedure StopRAff;
Procedure ForceGlobalRefresh;
Procedure GlobalRefresh;
Procedure DelayRAff;
Procedure InitRAffSystem;
Procedure BackRefresh;
Procedure ReportRAff( Temps : Word );
Procedure ReadyForRAff;
Procedure ResetRAff;      { Remettre  zro le raffraichissement }
Procedure ClrDelayRAff;

Procedure CommandesDos;
procedure ImageTelephone( var M : MemPg_Rec );
procedure ParamChoix( var M : MemPg_Rec );

Implementation

Const LN_NIL = $FF;

Var

     LgRAff    : Byte;
     TabRAff   : Array[0..ScreenHigh-1] Of Byte;
     BackRAff  : Boolean;

     BaseRAff  : Longint;  { <>0=> raffraichissement necessaire }
     WaitRAff  : Word;
     CanRAff   : Boolean;  { Passe  TRUE si raffraichissement possible }

     BaseNoRAff : Longint;
     WaitNoRAff : Word;


Procedure AbortCurrentRAff;
Begin
 If VDInUse Then
  Begin
   WaitUSXY  := FALSE;
   ResetCur  := TRUE;
  End
 Else ResetCur  := FALSE;
 VDInUse   := FALSE;
End;


Procedure ResetRAff;      { Remettre  zro le raffraichissement }
Begin
 AbortCurrentRAff;
 BaseRAff := GetC18;
 WaitRAff := 0;
 CanRAff := FALSE;
End;


Procedure LnRAff( nLn : Byte );
Var i : Byte;
Begin
 ResetRAff;
 i := 0;
 While (i<LgRAff) Do
  If TabRAff[i]=nLn Then Exit     { Dj en mmoire }
  Else Inc(i);
 TabRAff[LgRAff] := nLn;
 Inc(LgRAff);
End;


Procedure LnSRAff( nLn, Nb : Byte );
Begin
 While Nb>0 Do
  Begin
   LnRAff( nLn );
   Inc(nLn);
   Dec(Nb);
  End;
End;

Procedure ClrDelayRAff;
Begin
 BaseNoRAff := 0;
 WaitRAff   := 0;
End;


Procedure StopRAff;
Begin
 AbortCurrentRAff;
 LgRAff := 0;
 BaseRAff := 0;
 CanRAff := FALSE;
End;


Procedure ForceGlobalRefresh;
Begin
 StopRAff;
 ClrDelayRAff;
 LnSRAff( 1, ScreenHigh-1 );
End;

Procedure GlobalRefresh;
Begin
 LnSRAff( 1, ScreenHigh-1 );
End;


Procedure BackRefresh;
Begin
 BackRAff := TRUE;
End;


Procedure ReportRAff( Temps : Word );
Begin
 If BaseRAff<>0 Then
  Begin
   BaseRAff := GetC18;
   WaitRAff := Temps;
  End;
End;

Procedure CompoChg( nLn, Nb : Byte );
Begin
 MemChange(cM^);
 LnSRAff( nLn, Nb );
 ResetRAff;
End;

Procedure DelayRAff;
Begin
 BaseNoRAff := GetC18;
 WaitNoRAff := 18*10;
 WaitUSXY   := TRUE;
End;

Procedure DoBackRAff;
Begin
 If cM^.IntroRAff Then
  Begin
   If CreatBackGround(BackRam,BackDRCS,cM^,FALSE) Then;
  End
 Else
  Begin
   ClearRam(BackRam);
   ClearRamDRCS(BackDRCS);
  End;
End;


Procedure ReadyForRAff;
Begin
 CanRAff := TRUE;
End;


Const GenVDCfg : VDispCfg = (
        CSI          : FALSE;
        OptInvGrp    : FALSE;
        GXor         : FALSE;
        OptInvTxt    : FALSE;
        OptRepet     : TRUE;
        xRep         : FALSE;
        ComplAsSpace : FALSE;
        ForceDelGrp  : FALSE;
        ForceDelTxt  : FALSE;
        VideAsSpace  : TRUE;
        OptWithCan   : TRUE;
        OptSpclGrp   : TRUE;
        OptSpclTxt   : FALSE;
        C15Clr       : FALSE;
        OptMem       : OM_Nothing;
        DebCursor    : FALSE;
        OptNilDRCS   : TRUE;
        NoCR         : FALSE;
        Scroll       : FALSE
       );


Procedure AfficheBack;
Var iY, iX : Byte;
    s     : String;
    El    : PVDispRamEl;
Begin
 If CreatBack(BackRam,BackDRCS,cM^.Back,TRUE) Then
  Begin
   StopRAff;

   InitVD(GenVD,GenVD.Ram,GenVD.DRCS,BackDRCS);
   GenVD.Cfg := GenVDCfg;
   GenVD.Cfg.VideAsSpace := TRUE;

   For iY := 1 To ScreenHigh-1 Do
    For iX := 0 To ScreenLong-1 Do
     Begin
      El := @BackRam^[iY,iX];

      TransCode(GenVD,iX,iY,El^.Car,El^.Att,s);
      Mntl.Write(s);
      If AbortRequest Then
       Begin { Fin !!! }
        iX := ScreenLong-1;
        iY := ScreenHigh-1;
       End;
     End;

   FlushTrans(GenVD,s);
   Mntl.Write(s);

   ResetTrans(GenVD,s);
   Mntl.Write(s);
(*
   cM^.IntroFondRAff := TRUE;
*)
   BackRefresh;
  End;
End;


Function GetNextLine : Byte;
Begin
 If LgRAff>0 Then
  Begin
   Dec(LgRAff);
   GetNextLine := TabRAff[0];
   If LgRAff>0 Then
    Move(TabRAff[1],TabRAff[0],LgRAff*SizeOf(TabRAff[0]));
  End
 Else GetNextLine := LN_NIL;
End;


Procedure RAffPage;
Var iY,iX : Byte;
    s     : String;
    El    : PVDispRamEl;
Begin
 If VDInUse Then
  Begin
   If Mntl.TransmitCount=0 Then
    Begin
     If BackRAff Then
      Begin
       DoBackRAff;
       BackRAff := FALSE;
      End;

     iY := GetNextLine;
     If iY<>LN_NIL Then
      Begin

       For iX := 0 To ScreenLong-1 Do
        Begin
         El := @cM^.Ram[iY,iX];
         If (El^.Car=#0) And (cM^.IntroRAff) Then El := @BackRam^[iY,iX];

         TransCode(GenVD,iX,iY,El^.Car,El^.Att,s);
         Mntl.Write(s);
        End;

       FlushTrans(GenVD,s);
       Mntl.Write(s);

       ResetTrans(GenVD,s);
       Mntl.Write(s);

      End
     Else
      Begin

       VDInUse   := FALSE;
       ResetCur  := TRUE;

       BaseRAff  := 0;

       WaitUSXY  := FALSE;

       CurMntl   := FALSE;
      End;
    End;
  End
 Else
  If CanRAff (* And (BaseRAff<>0) *) Then
   If BaseNoRAff<>0 Then
    Begin
     If BaseNoRAff+WaitNoRAff<=GetC18 Then
      Begin
       BaseNoRAff := 0;
       WaitUSXY   := FALSE;
      End;
    End
   Else
    If (BaseRAff+WaitRAff<=GetC18) And (BaseRAff<>0) Then
     Begin
(*
      ClearRam(GenVD.Ram);
      ClearRamDRCS(GenVD.DRCS);
*)
      InitVD(GenVD,GenVD.Ram,GenVD.DRCS,@cM^.DRCS);
      GenVD.Cfg := GenVDCfg;
      GenVD.Cfg.VideAsSpace := Cfg.GlobalRAff Or cM^.IntroRAff;

      VDInUse  := TRUE;
      WaitUSXY := TRUE;
     End;
End;


Procedure InitRAffSystem;
Begin
 LgRAff    := 0;
 BaseNoRAff := 0;
 VDInUse := FALSE;
 BackRAff := TRUE;
 ResetCur := TRUE;
 WaitUSXY := FALSE;
 BackRefresh;
 GlobalRefresh;
 ResetRAff;
End;


Procedure CommandesDos;
Var io : Word;
    io2 : Word;
    Reg : Registers;
    SaveDir : PathStr;
Begin
 KeepVideo;

 Writeln;
 Writeln('Tapez EXIT pour revenir  '+SOFTNAME+' ...');

 GetDir(0,SaveDir);
 If IoResult<>0 Then SaveDir := '';

 KeepXSer;
 SwapVectors;

 Exec(GetEnv('COMSPEC'),'');

 io := DosError;

 SwapVectors;
 ResumeXSer;

 If SaveDir<>'' Then
  Begin
   ChDir(SaveDir);    { revenir au rpertoire de dpart }
   io2 := IoResult;
  End;

 ResumeVideo(Cfg.Grey,Cfg.EGALight);

 Reg.AX := $0000;
 IntMouse(Reg);

 (*
 CurOn;
 CurBig;
 *)
 If io<>0 then
  If io=2 then GestWindError(2,202,E_OK)
  Else GestWindError(2,io,E_OK);
End;


procedure ImageTelephone( var M : MemPg_Rec );
const Zn : Zn_Rec = (X:10; Y:5; lg:60; ht:3);
  procedure OnLine(texte : string);
  { ralenti l'emission car 4800->1200 }
  var index : byte;
  begin
    for index := 1 to length(texte) do
      begin
        Mntl.Write(texte[index]);
        if Cfg.CZ>=0 then delay(Cfg.Delay);
      end;
  end;
  procedure InWind(texte : string);
  var index : byte;
  begin
    WrtScr(CentreString(texte,Zn.lg-2,32),Zn.X+1,Zn.Y+1,CWind);
  end;
var long : word;
    data : byte;
    compteur : byte;
    w    : string[20];
    Ram  : RamFile;
begin
  PushZn(Zn);
  ClrZn(Zn,CWind);
  CCdrZn(Zn,CDRNORM,CCadre);
  InWind('COMPILATION DE L''IMAGE EN COURS');

  Ram.Init;
  if CompilVrai(Ram,M,FALSE) then
    begin
      long := Ram.Size;
      InWind('CONNEXION EN COURS ...');
      MinReset;
      Mntl.Write(Connect1200);
      if WaitInStr(#19#83,15*18,15*18,w) then
        begin
          Mntl.Write(Prise_On_Modem+Prise_Off_Ecran);
          WaitOutEmpty;
          delay(100);
          Mntl.ReceiveClear;  { vide buffer recep }
          InWind('EMISSION DE L''IMAGE EN COURS ...');
          compteur := 0;
          while (long>0) And Not(AbortRequest) do
            begin
              data := Ram.Get;
              if compteur=0 then
                if long<=127 then OnLine(MPRO2+char($66)+char(long))
                else OnLine(MPRO2+char($66)+char(127));
              dec(long);
              inc(compteur);
              if compteur>=127 then compteur := 0;
              Mntl.Write(char(data));
              if CFG.CZ>=0 then delay(CFG.Delay);
            end;
          WaitOutEmpty;
          InWind('DECONNEXION');
          OnLine(MPRO2+char($66)+
                 char(length(MPROReset)+length(Deconnect))+     { transparance }
                 MPROReset+
                 Deconnect);
          WaitOutEmpty;
          delay(100);
        end;

      MinReset;
    end;
  Ram.Done;
  PopZn;
end;


Procedure LesOptions( Var M : MemPg_Rec );
Const Zn : Zn_Rec = ( x:16; y:09; lg:48; ht:16 );

  Procedure AffParam;
  Var Buf : String;
      lg  : Byte;
      x   : Byte;
  Begin
   lg := Zn.Lg-2;
   x  := Zn.X+1;

   With M.Param Do
    Begin

     if SauteVide then buf := 'Saute les vides '''+char(_RIEN)+''''
     else buf := 'Affiche les vides '''+char(_RIEN)+'''';
     WrtScr(CentreString(buf,lg,32),x,Zn.Y+1,FWind+TNet);
     if ComplAsSpace then
     buf := 'Affiche les complements '''+char(Complement)+''''
     else
     buf := 'Saute les complements '''+char(Complement)+'''';
     WrtScr(CentreString(buf,lg,32),x,Zn.Y+2,FWind+TNet);

     If OptRepet Then
      Begin
       Buf := 'Optimisation des Rptitions';
       If xRep Then Buf := Buf+' (Standard)';
      End
     Else Buf := 'Pas d''Optimisation des Rptitions';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+3,FWind+TNet);

     If OptSpclGrp Then Buf := 'Optimisation Spciale Graphique'
     Else Buf := 'Pas d''Optimisation Spciale Graphique';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+4,FWind+TNet);

     If OptSpclTxt Then
      Begin
       Buf := 'Optimisation Spciale Texte';
       If C15Clr Then Buf := Buf+' (M2 Philips)';
      End
     Else Buf := 'Pas d''Optimisation Spciale Texte';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+5,FWind+TNet);

     If CSI Then Buf := 'Optimisation avec des Squences CSI'
     Else Buf := 'Pas de Squence CSI';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+6,FWind+TNet);

     Case OptMem Of
      OM_Some  : Buf := 'Optimise Parfois si Dj en Mmoire';
      OM_All   : Buf := 'Optimise Toujours si Dj en Mmoire';
     Else Buf := 'Ignore si Dj en Mmoire';
     End;

     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+7,FWind+TNet);

     If OptInvGrp Then Buf := 'Optimisation des Effets Invisibles Graphique'
     Else Buf :=  'Ignore si Effets Invisibles Graphique';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+8,FWind+TNet);

     If OptInvTxt Then Buf := 'Optimisation des Effets Invisibles Texte'
     Else Buf :=  'Ignore si Effets Invisibles Texte';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+9,FWind+TNet);

     If DebCursor Then Buf := 'Optimise par Dbordement du Curseur'
     Else Buf := 'Pas de Dbordement du Curseur';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+10,FWind+TNet);

     Buf := 'Force Dlimiteurs ';
     Case (Byte(ForceDelGrp) And 1) Or ((Byte(ForceDelTxt) And 1) Shl 1) Of
      1 : Buf := Buf+'Graphiques';
      2 : Buf := Buf+'Textes';
      3 : Buf := Buf+'Graphiques & Textes';
     Else Buf := 'Ne Force Aucun Dlimiteur';
     End;
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+11,FWind+TNet);

     Buf := 'Code RC (0Dh) ';
     If NoCR Then Buf := Buf+'Exclu' Else Buf := Buf+'Autoris';
     WrtScr(CentreString(Buf,lg,32),x,Zn.Y+12,FWind+TNet);
    End;

  End;

Var EndB  : Boolean;
    sauve : Param_Map;
    i     : Byte;

 Procedure Abandon;
 Begin
  M.Param := sauve;
  EndB := TRUE;
 End;

 Procedure ItsOk;
 Begin
  EndB := TRUE;   { Ok }
 End;

Begin
 sauve := M.Param;

 EmpileFld;

 PushZn(Zn);
 ClrZn(Zn,FWind+TNet);
 CCdrZn(Zn,CDRNORM,CCadre);

(*
 WrtScr('Optimisations',Zn.X+1,Zn.Y,CCadre);
*)

 AffParam;

 WrtScr(' ABANDON ',Zn.X+2,Zn.Y+14,CChoix);
 WrtScr('   OK   ',Zn.X+38,Zn.Y+14,CChoix);

 For i := 110 To 121 Do ChsFld(i);

 ChsFld(125);
 ChsFld(138);

 EndB := FALSE;

 Repeat
  If Interaction Then
   If (key=#0) Then
    Begin
     With M.Param Do
      Case Inter.SelectField Of
       110 : Abandon;
       111 : ItsOk;
       121 : SauteVide := not(SauteVide);
       125 : ComplAsSpace := not(ComplAsSpace);
       112 : Begin
              If OptRepet Then
               If xRep Then
                Begin
                 OptRepet := FALSE;
                 xRep     := FALSE;
                End
               Else xRep := TRUE
              Else OptRepet := TRUE;
             End;
       113 : OptSpclGrp := Not(OptSpclGrp);
       114 : If OptSpclTxt Then
              If C15Clr Then
               Begin
                OptSpclTxt := FALSE;
                C15Clr     := FALSE;
               End
              Else C15Clr := TRUE
             Else OptSpclTxt := TRUE;
       115 : CSI := Not(CSI);
       116 : Begin
              Inc(OptMem);
              If OptMem>2 Then OptMem := 0;
             End;
       117 : OptInvGrp := Not(OptInvGrp);
       118 : OptInvTxt := Not(OptInvTxt);
       119 : DebCursor := Not(DebCursor);
       120 : Begin
              i := (Byte(ForceDelGrp) And 1) Or ((Byte(ForceDelTxt) And 1) Shl 1);
              Inc(i);
              ForceDelGrp := (i And 1)<>0;
              ForceDelTxt := (i And 2)<>0;
             End;
       138 : NoCR := Not(NoCR);
      Else NoFieldLand;
      End;

     AffParam;
    End
   Else
    If Not(Funct) Then
     Begin
      Case UpCase(Key) Of
       #27,'A' : Abandon;
       #13,'O' : ItsOk;
      Else TheBeep;
      End;
     End
    Else TheBeep;
 Until EndB;

 PopZn;

 DepileFld;
End;

procedure ParamChoix( var M : MemPg_Rec );
const pZn : Zn_Rec = (x:19; y:0; lg:42; ht:24);
      iZn : Zn_Rec = (x:20; y:2; lg:40; ht:7+1);
      dZn : Zn_Rec = (x:20; y:7+2; lg:40; ht:7-2);
      cZn : Zn_Rec = (x:20; y:13; lg:40; ht:9-4);
      CurStat : array[0..2] of string[16] =
                ('Curseur inchang','Curseur allum','Curseur teint');
      AffStat : array[0..5] of string[15] =
                ('normal Haut'#26'Bas','Bas'#26'Haut',
                 'montant','descendant','Gauche'#26'Droite',
                 'Droite'#26'Gauche');

      NoInsert = 'Pas d''insertion';
      InsertOf = 'Insertion de ';
var PRang : byte;
    NumFichBase,NumFichParam : byte;

 Procedure AffBack;
 var buf : string;
     lg  : byte;
     x   : byte;
 Begin
  lg := pZn.Lg-2;
  x  := pZn.X+1;
  If Length(M.Back)>0 Then Buf := 'Non Vide'
  Else Buf := 'Vide';
  WrtScr(CentreString('Fond '+Buf,lg,32),x,pZn.Y+1,FWind+TNet);
 End;

 procedure AffIntroduc;
 var buf : string;
     lg  : byte;
     x   : byte;
 begin
  lg := iZn.lg-2;
  x  := iZn.X+1;
  with M.param do
  begin
   if LongChain=0 then buf := 'Pas de chainage'
   else
     begin
       str(LongChain,buf);
       buf := 'Chainage avec '+buf+' fichier';
       if LongChain>1 then buf := buf+'s';
     end;
   WrtScr(CentreString(buf,lg,32),X,iZn.Y+1,FWind+TNet);
   if LgCode1=0 then buf := NoInsert
   else
     begin
       str(LgCode1,buf);
       buf := InsertOf+buf+' code';
       if LgCode1>1 then buf := buf+'s';
     end;
   WrtScr(CentreString(buf,lg,32),X,iZn.Y+2,FWind+TNet);
   WrtScr(CentreString(CurStat[IntroCur],lg,32),
            X,iZn.Y+3,FWind+TNet);
   if VideLnZero then buf := 'Vide la ligne zro'
   else buf := 'Ne vide pas la ligne zro';
   WrtScr(CentreString(buf,lg-2,32),X+1,iZn.Y+4,FWind+TNet);
   if VideEcran then buf := 'Vide l''ecran'
   else buf := 'Ne vide pas l''ecran';
   WrtScr(CentreString(buf,lg-2,32),X+1,iZn.Y+5,FWind+TNet);

   If ForceCur Then Buf := 'Force positionnement du Curseur'
   Else Buf := 'Ne Force Pas le Curseur';
   WrtScr(CentreString(Buf,lg,32),x,iZn.Y+6,FWind+TNet);

  end;
 end;

 procedure AffDevelop;
 var buf : string;
     lg  : byte;
     x   : byte;
 begin
  lg := dZn.lg-2;
  x  := dZn.X+1;
  with M.param do
  begin
   Buf := 'Affichage '+AffStat[ModeAff];

   WrtScr(CentreString(Buf,lg,32),X,dZn.Y+1,FWind+TNet);

   Buf := 'Sens d''criture ';

   If ModeAff<M_GaucheDroite Then
    Begin
     If Inverse Then Buf := Buf+#27 Else Buf := Buf+#26;
     If ZigZag Then
      If Inverse Then Buf := Buf+' / '#26 Else Buf := Buf+' / '#27;
    End
   Else
    Begin
     If Inverse Then Buf := Buf+#24 Else Buf := Buf+#25;
     If ZigZag Then
      If Inverse Then Buf := Buf+' / '#25 Else Buf := Buf+' / '#24;
    End;

   WrtScr(CentreString(Buf,lg,32),X,dZn.Y+2,FWind+TNet);

 (*
   if OptimiseRep then buf := 'Optimisation des rptitions'
   else buf := 'Pas d''optimisation des rptitions';
 *)
   WrtScr(CentreString('Options d''optimisations & Codages',lg,32),X,dZn.Y+3,FWind+TNet);
  end;
 end;


 Procedure AffPlaceCur( x, y, lg : Byte );
 Var buf : String;
 Begin
  if M.Param.PlaceCur then buf := 'Placement du curseur'
  else buf := 'Pas de placement';
  WrtScr(CentreString(buf,lg,32),X,Y,FWind+TNet);
 End;


 procedure AffConclus;

 var buf : string;
     index : byte;
 begin
  with M.param do
  begin

   AffPlaceCur(cZn.X+1,cZn.Y+1,cZn.lg-2);

   WrtScr(CentreString(CurStat[ConcluCur],cZn.lg-2,32),
          cZn.X+1,cZn.Y+2,FWind+TNet);
   if LgCode2=0 then buf := NoInsert
   else
     begin
       str(LgCode2,buf);
       buf := InsertOf+buf+' code';
       if LgCode2>1 then buf := buf+'s';
     end;
   WrtScr(CentreString(buf,cZn.lg-2,32),cZn.X+1,cZn.Y+3,FWind+TNet);
  end;
 end;

  procedure MenuParam;
  begin
    NumFichBase := SaveZn(pZn);
    ClrZn(pZn,CWind);
    CCdrZn(pZn,CDRNORM,CCadre);
    CCdrZn(iZn,CDRNORM,CCadre);
    WrtScr('Introduction',iZn.X+1,iZn.Y,CCadre);
    CCdrZn(dZn,CDRNORM,CCadre);
    WrtDt(195,dZn.X,dZn.Y,CCadre);
    WrtScr('Dveloppement',dZn.X+1,dZn.Y,CCadre);
    WrtDt(180,dZn.X+dZn.lg-1,dZn.Y,CCadre);
    CCdrZn(cZn,CDRNORM,CCadre);
    WrtDt(195,cZn.X,cZn.Y,CCadre);
    WrtScr('Conclusion',cZn.X+1,cZn.Y,CCadre);
    WrtDt(180,cZn.X+cZn.lg-1,cZn.Y,CCadre);
    AffBack;
    AffIntroduc;
    AffDevelop;
    AffConclus;
    WrtScr(' Initialiser ',pZn.X+15,pZn.Y+22,CChoix);
    WrtScr(' ABANDON ',pZn.X+2,pZn.Y+22,CChoix);
    WrtScr('   OK   ',pZn.X+32,pZn.Y+22,CChoix);
  end;

  function CorrectorChain( var texte : string) : byte;
  { corrige la forme de la commande de chainage }
  { retourne le nombre de pseudo fichier trouve }
  var index : word;
      HowMany : byte;
      Result : string;
      morceau : string;
      tempo : word;
  begin
    KillData(texte,32);
    UpCaseStr(texte);
    index := 1;
    HowMany := 0;
    result := '';
    while (index<=length(texte)) do
      begin
        tempo := Pos('+',texte);
        if tempo<=0 then tempo := length(texte)+1
        else texte[tempo] := '\'; { change '+' en '\' }
        morceau := copy(texte,index,tempo-index); { prend pseudo-nom }
        (*
        CorrectorFileName(morceau);
         on ne corrige plus,  cause du "!"
        *)
        if morceau<>'' then
          begin
            if result<>'' then result := result+'+'+morceau
            else result := morceau;
            Inc(HowMany);
          end;
        index := tempo+1;
      end;
    CorrectorChain := HowMany;
    texte := result;
  end;

  procedure EnterChain;
  const ZnChain : Zn_Rec = (x:7; y:3+1; lg:66; ht:3);
  var s : string;
      pos : word;
  begin
    PushZn(ZnChain);
    ClrZn(ZnChain,FWind+TNet);
    CCdrZn(ZnChain,CDRNORM,CCadre);
    s := M.Chain;
    pos := 256;
    if InputString(s,pos,255,ZnChain.lg-2,ZnChain.X+1,ZnChain.Y+1) then
      begin
        M.Chain := s;
        M.param.LongChain := CorrectorChain(M.Chain);
      end;
    PopZn;
  end;

  procedure EnterBack;
  const ZnBack : Zn_Rec = (x:7; y:2; lg:66; ht:3);
  var s : string;
      pos : word;
      x : Byte;
  begin
    PushZn(ZnBack);
    ClrZn(ZnBack,FWind+TNet);
    CCdrZn(ZnBack,CDRNORM,CCadre);
    s := M.Back;
    pos := 256;
    if InputString(s,pos,255,ZnBack.lg-2,ZnBack.X+1,ZnBack.Y+1) then
      begin
        M.Back := s;
        x := CorrectorChain(M.Back);
      end;
    PopZn;
  end;

  const ZnCode1 : Zn_Rec = (x:7; y:4+1; lg:66; ht:3);
  const ZnCode2 : Zn_Rec = (x:7; y:21-4; lg:66; ht:3);
  procedure EnterCodeX( var Code : string; var LgCode : byte; var Zn : Zn_Rec );
  var n : word;
      s : string;
      t : string;
      EmulStr : Boolean;
  begin
    PushZn(Zn);
    ClrZn(Zn,FWind+TNet);
    CCdrZn(Zn,CDRNORM,CCadre);
    n := 256;
    s := Code;
    repeat
      if InputString(s,n,255,Zn.lg-2,Zn.X+1,Zn.Y+1) then
        begin
          t := s;
          n := TradString(t,EmulStr);
          if n=0 then
            begin
              Code := s;
              LgCode := length(t);
            end;
        end
      else n := 0;
    until n=0;
    PopZn;
  end;

  Procedure WindowPlaceCur( Var PY : Byte );
  Const cZn : Zn_Rec = (x:20; y:15; lg:40; ht:9);
        TabPPanel : array[0..3,0..1] of byte =
                     ( (0,0),(2,1),(3,4),(4,5) );

   Procedure AffPlacement;

    procedure AffAttPPanel(ref : word; NumAtt,x,y : byte);
    begin
      WrtScr(TxtAtt[NumAtt],x,y,FWind+TMiNet);
      WrtScr(GivTxtAtt(ref,NumAtt),x+9,y,FWind+TNet);
    end;

   var buf : string;
       index : byte;
   Begin
    AffPlaceCur(cZn.X+1,cZn.Y+1,cZn.lg-2);

    With M.Param Do
     if PlaceCur then
       begin
         for index := 94 to 101 do Field[index].vis := true;
         WrtScr('Ligne '+Complete(PLigne+1,2,'0')+
                '  Colonne '+Complete(PColonne+1,2,'0')+'   pointer',
                cZn.X+5,cZn.Y+2,FWind+TNet);
         if (PPanel and Graphik)=0 then
           begin
             buf := 'Texte';
             PRang := 0;
           end
         else
           begin
             buf := 'Graphique';
             PRang := 1;
           end;
         WrtScr(CentreString('Mode '+buf,cZn.lg-2,32),cZn.X+1,cZn.Y+3,FWind+TNet);
         if (PPanel and Graphik)=0 then
           begin { texte }
             AffAttPPanel(PPanel,0,cZn.x+1,cZn.Y+4); { trait }
             AffAttPPanel(PPanel,2,cZn.x+1,cZn.Y+5); { taille }
             AffAttPPanel(PPanel,3,cZn.x+21,cZn.Y+4); { inver }
             AffAttPPanel(PPanel,4,cZn.x+21,cZn.Y+5); { stable }
           end
         else
           begin
             AffAttPPanel(PPanel,0,cZn.x+1,cZn.Y+4); { trait }
             AffAttPPanel(PPanel,1,cZn.x+1,cZn.Y+5); { fond }
             AffAttPPanel(PPanel,4,cZn.x+21,cZn.Y+4); { stable }
             AffAttPPanel(PPanel,5,cZn.x+21,cZn.Y+5); { souli }
           end;
       end
     else
       begin
         for index := 94 to 101 do Field[index].vis := false;
         buf := FillString(cZn.lg-2,32);
         for index :=0 to 3 do WrtScr(buf,cZn.X+1,cZn.Y+2+index,FWind+TNet);
       end;
   End;

  Var i : Byte;
      EndB : Boolean;
      sauvegarde : Param_Map;

   Procedure Abandon;
   Begin
    M.param := sauvegarde;
    EndB := TRUE;
   End;

   Procedure ItsOk;
   Begin
    EndB := TRUE;
   End;

  Begin
   EmpileFld;

   For i := 94 To 101 Do ChsFld(i);

   ChsFld(122);
   ChsFld(123);
   ChsFld(124);

   PushZn(cZn);

   ClrZn(cZn,CWind);
   CCdrZn(cZn,CDRNORM,CCadre);

   AffPlacement;

   WrtScr(' ABANDON ',cZn.X+1,cZn.Y+cZn.Ht-2,CChoix);
   WrtScr('   OK   ',cZn.X+31,cZn.Y+cZn.Ht-2,CChoix);

   sauvegarde := M.Param;

   EndB := FALSE;

   With M.Param Do
    While Not(EndB) Do
     Begin
      if interaction Then
       If (key=#0) then
        begin
         case inter.SelectField of
          123 : Abandon;
          124 : ItsOk;

          122 : Begin
                 PlaceCur := not(PlaceCur);
                 AffPlacement;
                End;
          94..101 :
              Begin
               if PlaceCur then
                 begin
                   if inter.SelectField=97 then PPanel := PPanel xor Graphik
                   else
                     if (inter.SelectField>=98) and (inter.SelectField<=101) then
                       if inter.BtnGauche then
                         IncAtt(PPanel,TabPPanel[inter.SelectField-98,PRang])
                       else
                         DecAtt(PPanel,TabPPanel[inter.SelectField-98,PRang])
                     else
                       if inter.SelectField=94 then
                         if inter.BtnGauche then
                           if PLigne>=23 then PLigne := 0
                           else Inc(PLigne)
                         else
                           if PLigne=0 then PLigne := 23
                           else Dec(PLigne)
                       else
                         if inter.SelectField=95 then
                           if inter.BtnGauche then
                             if PColonne>=39 then PColonne := 0
                             else Inc(PColonne)
                           else
                             if PColonne=0 then PColonne := 39
                             else Dec(PColonne)
                         else
                           if inter.SelectField=96 then
                             begin { pointe }
         NumFichParam := SaveZn(pZn);
         PYhaut := PY;
         RstZn(NumFichBase);
         EmpileFld;
         EndB := FALSE;
         repeat
           If Interaction Then
            Begin
             If Not(Funct) Then
              Begin
               Case UpCase(Key) Of
                #27 : EndB := TRUE;
                (*
                #13 : Begin
                       If CompoField Then
                        Begin
                         PLigne := CurY-1;
                         PColonne := CurX;
                         EndB := TRUE;
                        End
                       Else TheBeep;
                      End;
                *)
               Else TheBeep;
               End;
              End
             Else TheBeep;
            End
           Else
            If (Key=#0) Then
             Begin
              If ButtonL and CompoField then
               begin
                 EndB := true;
                 PLigne := CurY-1;
                 PColonne := CurX;
               end;
             End
            Else
             Begin
              If Not(Funct) Then
               Begin
                Case UpCase(Key) Of
                 #27 : EndB := TRUE;
                 #13 : Begin
                        If CompoField Then
                         Begin
                          PLigne := CurY-1;
                          PColonne := CurX;
                          EndB := TRUE;
                         End
                        Else TheBeep;
                       End;
                Else TheBeep;
                End;
               End
              Else TheBeep;
             End;
         until EndB;
         EndB := FALSE;
         PY := PYhaut;
         PYhaut := ScreenHigh;
         DepileFld;
         RstZn(NumFichParam);
         CloseZn(NumFichParam);
                             end;
                 end;

               AffPlacement;
              End;
         Else NoFieldLand;
         End;
        End
       Else
        If Not(Funct) Then
         Begin
          Case UpCase(Key) Of
           #27,'A' : Abandon;
           #13,'O' : ItsOk;
          Else TheBeep;
          End;
         End
        Else TheBeep;


     End;
(*
   Delay(1000*3);
*)
   PopZn;

   DepileFld;
  End;

var EndBoucle : boolean;
    sauvegarde : param_map;
    SauveChainString : string;
    SauveCode1 : string;
    SauveCode2 : string;
    SauveBack  : String;
    index,PY : byte;
    n          : Byte;

 Procedure Abandon;
 Begin
  M.param := sauvegarde;
  M.Chain := SauveChainString;
  M.Code1 := SauveCode1;
  M.Code2 := SauveCode2;
  EndBoucle := true;
 End;

 Procedure ItsOk;
 Begin
  EndBoucle := true;
 End;

 Procedure InitThis;
 Begin
  InitParametrage(M);
  AffIntroduc;
  AffDevelop;
  AffConclus;
 End;

begin
 sauvegarde := M.param;
 SauveChainString := M.Chain;
 SauveCode1 := M.Code1;
 SauveCode2 := M.Code2;
 SauveBack  := M.Back;
 with M.param do
 begin
  EmpileFld;
  for index := 83 to 93 do ChsFld(index);
  ChsFld(102);
  ChsFld(103);
  ChsFld(105);
  ChsFld(108);
  ChsFld(109);
  MenuParam;
  EndBoucle := false;
  PY := PYhaut;
  PYhaut := ScreenHigh;
  repeat
    if interaction Then
     If (key=#0) then
      begin
        case inter.SelectField of
          83 : begin { init }
                 InitThis;
               end;
          84 : begin { ok }
                 ItsOk;
               end;
          103 : begin { abandon }
                 Abandon;
                end;
          90 : Begin
                EnterBack;
                AffBack;
               End;

          85..87,105,108, 91 :
            begin { intro }
              case inter.SelectField of
                85 : begin
                       Inc(IntroCur);
                       if IntroCur>2 then IntroCur := 0;
                     end;
                86  : VideLnZero := not(VideLnZero);
                87  : VideEcran := not(VideEcran);
                105 : EnterChain;
                108 : EnterCodeX(M.Code1,M.param.LgCode1,ZnCode1);
                90  : ; { Fond }
                91  : ForceCur := Not(ForceCur); { Force Curseur }
              end;
              AffIntroDuc;
            end;
          88..89,92 : begin { developpement }
  case inter.SelectField of
    88 : begin
           Inc(ModeAff);
           if ModeAff>5 then ModeAff := 0;
         end;
    89 : Begin
          n := (Byte(Inverse) And 1) Or ((Byte(ZigZag) And 1) Shl 1);
          Inc(n);
          Inverse := (n And 1)<>0;
          ZigZag  := (n And 2)<>0;
         End;
    92 : LesOptions(M);
  end;
  AffDevelop;
                   end;
          93..102,109 : begin { conclu }
  case inter.SelectField of
   93 : WindowPlaceCur(PY);
   109 : EnterCodeX(M.Code2,M.param.LgCode2,ZnCode2);
   102 : begin
           Inc(ConcluCur);
           if ConcluCur>2 then ConcluCur := 0;
         end;
  end;
  AffConclus;
                   end;
        else NoFieldLand;
        end;
      end
    Else
     Begin
      If Not(Funct) Then
       Begin
        Case UpCase(Key) Of
         #27, 'A' : Abandon;
         #13, 'O' : ItsOk;
         'I'      : InitThis;
        End;
       End
      Else TheBeep;
     End;
  until EndBoucle;
  if not(EgalMem(M.param,sauvegarde,sizeof(sauvegarde))) or
     (M.Chain<>SauveChainString) or
     (M.Code1<>SauveCode1) or
     (M.Code2<>SauveCode2) or
     (M.Back<>SauveBack) then MemChange(M);
  PYhaut := PY;
  RstZn(NumFichBase);
  CloseZn(NumFichBase);
  DepileFld;
 end; { with }

 BackRefresh;
 GlobalRefresh;
end;


End.
